#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Pelatis {
     char name [30];
     char phone[20];
     struct Pelatis *next;
} Pelatis;


struct Pelatis *FirstPelatis = NULL;
Pelatis *LastPelatis = NULL;

int ShowPelates(void) {
    Pelatis* temp = FirstPelatis;
    int i = 1;
    printf("\n");
    while( temp != NULL)	{
        printf("%d) %s\n", i, temp->name);
        temp = temp->next;
        i++;
   }
   printf("\n"); 
   if(i == 1)
   {
   	  printf("\nThe list is empty.\n\n");
   	  return -1;
   }
   
   return i;
}

int ChoosePelatis(void) {
    int all;
    int pos;
    
    if( (all = ShowPelates()) > 0)    {
       printf("Choose a pelatis number : ");
       pos = readINumber();

      if((pos > 0) && (pos <= all)){
          return pos;
       }
      else {
           printf("\nError : %d is not a valid option.\n", pos);
        }
    }  
    return -1;         
}




Pelatis *FindPelatis(int pos){   
   int index = 0;
   Pelatis* temp = FirstPelatis;
    
   while( temp != NULL) {
     index = index + 1;
   	 if(index == pos)
   	    return temp;
   	 else   
   	    temp = temp->next;
   }
   
    return NULL;         
}

void DeletePelatis(int pos)  {
   if(pos == 1)  {
           if(FirstPelatis != NULL) {
              Pelatis *temp = FirstPelatis;
              FirstPelatis = FirstPelatis->next;
              free(temp);
              temp = NULL;
           }
         return;
       }    
    if(pos > 1) {
          Pelatis* current  = FindPelatis (pos);
          Pelatis* previous = FindPelatis (pos-1);

          if((current != NULL) && (previous != NULL))  {
             previous->next = current->next;
            
              if(current-> next == NULL)
                LastPelatis = previous;

             free(current);
             current = NULL;
          }   
          else {
              printf("\nError : Not a valid number.\n");
          }     
      }    
} 

void AddNewPelatis(void) {
    char name[20], t;
    Pelatis* temp;
    temp = (Pelatis *) malloc( sizeof(Pelatis));
  if(temp == NULL) {
     printf("\nError : No enough memory.\n");
     return;
  }    
 
    printf("\nType pelatis name : ");
    gets(name);
    
    
    strcpy(temp->name, name);
    temp->next = NULL;
    
    if(FirstPelatis == NULL)  {
        FirstPelatis = temp;  
        LastPelatis = temp; 
    }    
    else {
        LastPelatis->next = temp; 
        LastPelatis = temp;
    }   
}


double readDNumber() {
	double x;

	char line[100];
	gets(line);
	
	return atof(line);
}

int readINumber() {
	double x;

	char line[100];
	gets(line);
	
	return atoi(line);
}

char getch()
{
	char line[100];
	gets(line);
	return line[0];
}

int DisplayMenu(void) {
    char ch, temp, index;
    int  t, ans = -1;

    printf("(N) New Pelatis\n");
    printf("(D) Delete Pelatis\n");
    printf("(L) List Pelates\n");;
    printf("(E) Exit\n");
    printf("Type your choice : "); 
	
	ch = getch();
    switch(ch)  {
            case 'n' :
            case 'N' :
                        AddNewPelatis();  break;
            case 'd' :
            case 'D' :  
			            index = ChoosePelatis();
			            if(index > 0)      
                           DeletePelatis(index);   
						break; 
            case 'l' :
            case 'L' :
						index = ShowPelates();   break;    
            case 'e' :
            case 'E' :
                        ans = 1;     break;                                              
            default:
                printf("Error : %c is not a valid option\n", ch);      
       }           
       return ans;
}    



int main(int argc, char *argv[]){
  
  while(DisplayMenu() < 0) {}
  
  return 0;
}



